diff --git a/core/src/aos_main.cpp b/core/src/aos_main.cpp
index 9fb60dd..654be93 100644
--- a/core/src/aos_main.cpp
+++ b/core/src/aos_main.cpp
@@ -1245,8 +1265,8 @@ aosprintf("Line 1123\n");
 #endif
 #endif
 
-    // initialize/acknowledge shutdown
-    aosSysShutdownInit(shutdown);
+  // initialize/acknowledge shutdown
+  aosSysShutdownInit(shutdown);
 
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1)
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_1_ARGS)
@@ -1256,8 +1276,8 @@ aosprintf("Line 1123\n");
 #endif
 #endif
 
-    // stop system threads
-    aosSysStop();
+  // stop system threads
+  aosSysStop();
 
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2)
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_2_ARGS)
@@ -1267,8 +1287,8 @@ aosprintf("Line 1123\n");
 #endif
 #endif
 
-    // deinitialize system
-    aosSysDeinit();
+  // deinitialize system
+  aosSysDeinit();
 
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3)
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3_ARGS)
@@ -1278,11 +1298,11 @@ aosprintf("Line 1123\n");
 #endif
 #endif
 
-    /* stop all periphery communication */
-    // CAN (mandatory)
-    canStop(&MODULE_HAL_CAN);
+  /* stop all periphery communication */
+  // CAN (mandatory)
+  canStop(&MODULE_HAL_CAN);
 #ifdef MODULE_SHUTDOWN_PERIPHERY_COMM
-    MODULE_SHUTDOWN_PERIPHERY_COMM();
+  MODULE_SHUTDOWN_PERIPHERY_COMM();
 #endif
 
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4)
@@ -1293,10 +1313,10 @@ aosprintf("Line 1123\n");
 #endif
 #endif
 
-    // finally hand over to bootloader
-    aosSysShutdownFinal(shutdown);
+  // finally hand over to bootloader
+  aosSysShutdownFinal(shutdown);
 
-    /*
+  /*
    * ##########################################################################
    * # after shutdown/restart                                                 #
    * ##########################################################################
@@ -1306,8 +1326,8 @@ aosprintf("Line 1123\n");
    *       which subsystems should NOT be shut down.
    */
 
-    // return an error, since this code should not be executed
-    return -1;
+  // return an error, since this code should not be executed
+  return -1;
 }
 
 /** @} */
diff --git a/core/src/aos_shell.c b/core/src/aos_shell.c
index e524faf..bf990b8 100644
--- a/core/src/aos_shell.c
+++ b/core/src/aos_shell.c
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -270,7 +270,6 @@ typedef enum charmatch {
  */
 static void _printPrompt(aos_shell_t* shell)
 {
-
   aosDbgCheck(shell != NULL);
 
   // print some time informattion before prompt if configured
@@ -312,6 +311,7 @@ static void _printPrompt(aos_shell_t* shell)
   } else {
     chprintf((BaseSequentialStream*)&shell->stream, "%>$ ");
   }
+
   return;
 }
 
diff --git a/core/src/aos_system.c b/core/src/aos_system.c
index f475d0d..e40d1ec 100644
--- a/core/src/aos_system.c
+++ b/core/src/aos_system.c
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -79,23 +79,19 @@ static aos_timestamp_t _uptime;
  */
 static systime_t _synctime;
 
-#if (AMIROOS_CFG_SSSP_ENABLE == true)
-#if (AMIROOS_CFG_SSSP_MASTER == true) || defined(__DOXYGEN__)
+#if ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MASTER == true)) || defined(__DOXYGEN__)
 /**
  * @brief   Timer to drive the SYS_SYNC signal for system wide time synchronization according to SSSP.
  */
 static virtual_timer_t _syssynctimer;
 
-#endif
-
 /**
  * @brief   Last uptime of system wide time synchronization.
  */
 static aos_timestamp_t _syssynctime;
 #endif
 
-#if (AMIROOS_CFG_SSSP_ENABLE == true)
-#if ((AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true)) || defined(__DOXYGEN__)
+#if ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true)) || defined(__DOXYGEN__)
 /**
  * @brief   Offset between local clock and system wide synchronization signal.
  */
@@ -105,8 +101,7 @@ static float _syssyncskew;
  * @brief   Weighting factor for the low-pass filter used for calculating the @p _syssyncskew value.
  */
 #define SYSTEM_SYSSYNCSKEW_LPFACTOR   (0.1f / AOS_SYSTEM_TIME_RESOLUTION)
-#endif
-#endif
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true) */
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 /**
@@ -146,7 +141,11 @@ static aos_shellcommand_t _shellcmd_config = {
  * @brief   Shell command to shutdown the system.
  */
 static aos_shellcommand_t _shellcmd_shutdown = {
+#if (AMIROOS_CFG_SSSP_ENABLE == true)
   /* name     */ "system:shutdown",
+#else
+  /* name     */ "module:shutdown",
+#endif
   /* callback */ _shellcmd_shutdowncb,
   /* next     */ NULL,
 };
@@ -242,7 +241,11 @@ static void _printSystemInfo(BaseSequentialStream* stream)
 
   // print static information about module and operating system
   _printSystemInfoSeparator(stream, '=', SYSTEM_INFO_WIDTH);
+#ifdef BOARD_VERSION
   _printSystemInfoLine(stream, "Module", SYSTEM_INFO_NAMEWIDTH, "%s (v%s)", BOARD_NAME, BOARD_VERSION);
+#else
+  _printSystemInfoLine(stream, "Module", SYSTEM_INFO_NAMEWIDTH, "%s", BOARD_NAME);
+#endif
 #ifdef PLATFORM_NAME
   _printSystemInfoLine(stream, "Platform", SYSTEM_INFO_NAMEWIDTH, "%s", PLATFORM_NAME);
 #endif
@@ -253,6 +256,8 @@ static void _printSystemInfo(BaseSequentialStream* stream)
   _printSystemInfoSeparator(stream, '-', SYSTEM_INFO_WIDTH);
 #if (AMIROOS_CFG_SSSP_ENABLE == true)
   _printSystemInfoLine(stream, "AMiRo-OS" , SYSTEM_INFO_NAMEWIDTH, "%u.%u.%u %s (SSSP %u.%u)", AMIROOS_VERSION_MAJOR, AMIROOS_VERSION_MINOR, AMIROOS_VERSION_PATCH, AMIROOS_RELEASE_TYPE, AOS_SYSTEM_SSSP_VERSION_MAJOR, AOS_SYSTEM_SSSP_VERSION_MINOR);
+#else
+  _printSystemInfoLine(stream, "AMiRo-OS" , SYSTEM_INFO_NAMEWIDTH, "%u.%u.%u %s", AMIROOS_VERSION_MAJOR, AMIROOS_VERSION_MINOR, AMIROOS_VERSION_PATCH, AMIROOS_RELEASE_TYPE);
 #endif
   _printSystemInfoLine(stream, "AMiRo-LLD" , SYSTEM_INFO_NAMEWIDTH, "%u.%u.%u %s (periphAL %u.%u)", AMIRO_LLD_VERSION_MAJOR, AMIRO_LLD_VERSION_MINOR, AMIRO_LLD_VERSION_PATCH, AMIRO_LLD_RELEASE_TYPE, PERIPHAL_VERSION_MAJOR, PERIPHAL_VERSION_MINOR);
   _printSystemInfoLine(stream, "ChibiOS/RT" , SYSTEM_INFO_NAMEWIDTH, "%u.%u.%u %s", CH_KERNEL_MAJOR, CH_KERNEL_MINOR, CH_KERNEL_PATCH, (CH_KERNEL_STABLE == 1) ? "stable" : "non-stable");
@@ -264,7 +269,6 @@ static void _printSystemInfo(BaseSequentialStream* stream)
   // print static information about the bootloader
   _printSystemInfoSeparator(stream, '-', SYSTEM_INFO_WIDTH);
   if (BL_CALLBACK_TABLE_ADDRESS->magicNumber == BL_MAGIC_NUMBER) {
-#if (AMIROOS_CFG_SSSP_ENABLE == true)
     _printSystemInfoLine(stream, "AMiRo-BLT", SYSTEM_INFO_NAMEWIDTH, "%u.%u.%u %s (SSSP %u.%u)", BL_CALLBACK_TABLE_ADDRESS->vBootloader.major, BL_CALLBACK_TABLE_ADDRESS->vBootloader.minor, BL_CALLBACK_TABLE_ADDRESS->vBootloader.patch,
                          (BL_CALLBACK_TABLE_ADDRESS->vBootloader.identifier == BL_VERSION_ID_AMiRoBLT_Release) ? "stable" :
                          (BL_CALLBACK_TABLE_ADDRESS->vBootloader.identifier == BL_VERSION_ID_AMiRoBLT_ReleaseCandidate) ? "release candidate" :
@@ -273,7 +277,7 @@ static void _printSystemInfo(BaseSequentialStream* stream)
                          (BL_CALLBACK_TABLE_ADDRESS->vBootloader.identifier == BL_VERSION_ID_AMiRoBLT_PreAlpha) ? "pre-alpha" :
                          "<release type unknown>",
                          BL_CALLBACK_TABLE_ADDRESS->vSSSP.major, BL_CALLBACK_TABLE_ADDRESS->vSSSP.minor);
-
+#if (AMIROOS_CFG_SSSP_ENABLE == true)
     if (BL_CALLBACK_TABLE_ADDRESS->vSSSP.major != AOS_SYSTEM_SSSP_VERSION_MAJOR) {
       if (stream) {
         chprintf(stream, "WARNING: Bootloader and AMiRo-OS implement incompatible SSSP versions!\n");
@@ -293,7 +297,7 @@ static void _printSystemInfo(BaseSequentialStream* stream)
 
   // print dynamic information about the module
   _printSystemInfoSeparator(stream, '-', SYSTEM_INFO_WIDTH);
-  #if (AMIROOS_CFG_SSSP_ENABLE == true)
+#if (AMIROOS_CFG_SSSP_ENABLE == true)
   if (aos.sssp.moduleId != 0) {
     _printSystemInfoLine(stream, "Module ID", SYSTEM_INFO_NAMEWIDTH, "%u", aos.sssp.moduleId);
   } else {
@@ -508,22 +512,23 @@ static int _shellcmd_infocb(BaseSequentialStream* stream, int argc, char* argv[]
   chprintf(stream, "%10u seconds\n", (uint8_t)(uptime % MICROSECONDS_PER_MINUTE / MICROSECONDS_PER_SECOND));
   chprintf(stream, "%10u milliseconds\n", (uint16_t)(uptime % MICROSECONDS_PER_SECOND / MICROSECONDS_PER_MILLISECOND));
   chprintf(stream, "%10u microseconds\n", (uint16_t)(uptime % MICROSECONDS_PER_MILLISECOND / MICROSECONDS_PER_MICROSECOND));
-#if (AMIROOS_CFG_SSSP_ENABLE == true)
-#if (AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true)
+#if (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true)
   chprintf(stream, "SSSP synchronization offset: %.3fus per %uus\n", _syssyncskew, AMIROOS_CFG_SSSP_SYSSYNCPERIOD);
 #endif /* AMIROOS_CFG_SSSP_MASTER != true && AMIROOS_CFG_PROFILE == true */
   _printSystemInfoSeparator(stream, '=', SYSTEM_INFO_WIDTH);
-#endif
+
 #if (AMIROOS_CFG_SHELL_ENABLE == true)
   // print shell info
   chprintf(stream, "System shell information:\n");
   chprintf(stream, "\tnumber of commands:      %u\n", aosShellCountCommands(&aos.shell));
   chprintf(stream, "\tmaximum line width:      %u characters\n", aos.shell.linesize);
   chprintf(stream, "\tmaximum #arguments:      %u\n", aos.shell.arglistsize);
+#if (AMIROOS_CFG_DBG == true)
   chprintf(stream, "\tshell thread stack size: %u bytes\n", aosThdGetStacksize(aos.shell.thread));
 #if (CH_DBG_FILL_THREADS == TRUE)
   chprintf(stream, "\tstack peak utilization:  %u bytes (%.2f%%)\n", aosThdGetStackPeakUtilization(aos.shell.thread), (float)aosThdGetStackPeakUtilization(aos.shell.thread) / (float)aosThdGetStacksize(aos.shell.thread) * 100.0f);
 #endif /* CH_DBG_FILL_THREADS == TRUE */
+#endif /* AMIROOS_CFG_DBG == true */
   _printSystemInfoSeparator(stream, '=', SYSTEM_INFO_WIDTH);
 #endif /* AMIROOS_CFG_SHELL_ENABLE == true */
 
@@ -545,6 +550,7 @@ static int _shellcmd_shutdowncb(BaseSequentialStream* stream, int argc, char* ar
 {
   aosDbgCheck(stream != NULL);
 
+#if (AMIROOS_CFG_SSSP_ENABLE == true)
   // print help text
   if (argc != 2 || strcmp(argv[1], "--help") == 0) {
     chprintf(stream, "Usage: %s OPTION\n", argv[0]);
@@ -592,6 +598,14 @@ static int _shellcmd_shutdowncb(BaseSequentialStream* stream, int argc, char* ar
       return AOS_INVALID_ARGUMENTS;
     }
   }
+#else /* AMIROOS_CFG_SSSP_ENABLE == false */
+  (void)argv;
+  (void)argc;
+
+  chEvtBroadcastFlags(&aos.events.os, AOS_SYSTEM_EVENTFLAGS_SHUTDOWN);
+  chThdTerminate(chThdGetSelfX());
+  return AOS_OK;
+#endif /* AMIROOS_CFG_SSSP_ENABLE */
 }
 
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
@@ -618,6 +632,9 @@ static int _shellcmd_kerneltestcb(BaseSequentialStream* stream, int argc, char*
 #endif /* AMIROOS_CFG_TESTS_ENABLE == true */
 #endif /* AMIROOS_CFG_SHELL_ENABLE == true */
 
+// suppress warning in case no interrupt GPIOs are defined
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wunused-function"
 /**
  * @brief   Generic callback function for GPIO interrupts.
  *
@@ -628,14 +645,14 @@ static void _intCallback(void* args)
   aosDbgCheck((args != NULL) && (*((iopadid_t*)args) < sizeof(eventflags_t) * 8));
 
   chSysLockFromISR();
-  chEvtBroadcastFlagsI(&aos.events.io, (eventflags_t)1 << *((iopadid_t*)args));
+  chEvtBroadcastFlagsI(&aos.events.io, AOS_IOEVENT_FLAG(*((iopadid_t*)args)));
   chSysUnlockFromISR();
 
   return;
 }
+#pragma GCC diagnostic pop
 
-#if (AMIROOS_CFG_SSSP_ENABLE == true)
-#if (AMIROOS_CFG_SSSP_MASTER != true) || defined(__DOXYGEN__)
+#if ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MASTER != true)) || defined(__DOXYGEN__)
 /**
  * @brief   Callback function for the Sync signal interrupt.
  *
@@ -672,13 +689,12 @@ static void _signalSyncCallback(void *args)
     }
   }
   // broadcast event
-  chEvtBroadcastFlagsI(&aos.events.io, (eventflags_t)1 << *((iopadid_t*)args));
+  chEvtBroadcastFlagsI(&aos.events.io, AOS_IOEVENT_FLAG(*((iopadid_t*)args)));
   chSysUnlockFromISR();
 
   return;
 }
-#endif
-#endif
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MASTER != true) */
 
 /**
  * @brief   Callback function for the uptime accumulation timer.
@@ -701,8 +717,8 @@ static void _uptimeCallback(void* par)
 
   return;
 }
-#if (AMIROOS_CFG_SSSP_ENABLE == true)
-#if (AMIROOS_CFG_SSSP_MASTER == true) || defined (__DOXYGEN__)
+
+#if ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MASTER == true)) || defined (__DOXYGEN__)
 /**
  * @brief   Periodic system synchronization callback function.
  * @details Toggles the SYS_SYNC signal and reconfigures the system synchronization timer.
@@ -736,8 +752,7 @@ static void _sysSyncTimerCallback(void* par)
 
   return;
 }
-#endif
-#endif
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MASTER == true) */
 
 /**
  * @brief   AMiRo-OS system initialization.
@@ -756,9 +771,9 @@ void aosSysInit(void)
 
   /* set local variables */
   chVTObjectInit(&_systimer);
+#if (AMIROOS_CFG_SSSP_ENABLE == true)
   _synctime = 0;
   _uptime = 0;
-  #if (AMIROOS_CFG_SSSP_ENABLE == true)
 #if (AMIROOS_CFG_SSSP_MASTER == true)
   chVTObjectInit(&_syssynctimer);
   _syssynctime = 0;
@@ -766,10 +781,17 @@ void aosSysInit(void)
 #if (AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true)
   _syssyncskew = 0.0f;
 #endif
-#endif
+#else /* AMIROOS_CFG_SSSP_ENABLE == false */
+  // start the uptime counter
+  chSysLock();
+  _synctime = chVTGetSystemTimeX();
+  _uptime = 0;
+  chVTSetI(&_systimer, SYSTIMER_PERIOD, &_uptimeCallback, NULL);
+  chSysUnlock();
+#endif /* AMIROOS_CFG_SSSP_ENABLE */
 
-  #if (AMIROOS_CFG_SSSP_ENABLE == true)
   /* initialize aos configuration */
+#if (AMIROOS_CFG_SSSP_ENABLE == true)
   aos.sssp.stage = AOS_SSSP_STARTUP_2_1;
   aos.sssp.moduleId = 0;
 #endif
@@ -778,8 +800,8 @@ void aosSysInit(void)
   chEvtObjectInit(&aos.events.os);
 
   /* interrupt setup */
+#if (AMIROOS_CFG_SSSP_ENABLE == true)
   // PD signal
-  #if (AMIROOS_CFG_SSSP_ENABLE == true)
   palSetPadCallback(moduleSsspGpioPd.gpio->port, moduleSsspGpioPd.gpio->pad, _intCallback, &moduleSsspGpioPd.gpio->pad);
   palEnablePadEvent(moduleSsspGpioPd.gpio->port, moduleSsspGpioPd.gpio->pad, APAL2CH_EDGE(moduleSsspGpioPd.meta.edge));
   // SYNC signal
@@ -799,7 +821,7 @@ void aosSysInit(void)
   palSetPadCallback(moduleSsspGpioUp.gpio->port, moduleSsspGpioUp.gpio->pad, _intCallback, &moduleSsspGpioUp.gpio->pad);
   palEnablePadEvent(moduleSsspGpioUp.gpio->port, moduleSsspGpioUp.gpio->pad, APAL2CH_EDGE(moduleSsspGpioUp.meta.edge));
 #endif
-#endif
+#endif /* AMIROOS_CFG_SSSP_ENABLE == true */
 #ifdef MODULE_INIT_INTERRUPTS
   // further interrupt signals
   MODULE_INIT_INTERRUPTS();
@@ -821,7 +843,7 @@ void aosSysInit(void)
 #if (AMIROOS_CFG_TESTS_ENABLE == true)
   aosShellAddCommand(&aos.shell, &_shellcmd_kerneltest);
 #endif
-#endif
+#endif /* AMIROOS_CFG_SHELL_ENABLE == true */
 
   return;
 }
@@ -847,7 +869,7 @@ inline void aosSysStart(void)
     chSysUnlock();
   }
 #endif
-#endif
+#endif /* AMIROOS_CFG_SSSP_ENABLE == true */
 
   // print system information;
   _printSystemInfo((BaseSequentialStream*)&aos.iostream);
@@ -864,7 +886,8 @@ inline void aosSysStart(void)
 
   return;
 }
-#if (AMIROOS_CFG_SSSP_ENABLE == true)
+
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
 /**
  * @brief   Implements the SSSP startup synchronization step.
  *
@@ -915,7 +938,7 @@ eventmask_t aosSysSsspStartupOsInitSyncCheck(event_listener_t* syncEvtListener)
     return m;
   }
 }
-#endif
+#endif /* AMIROOS_CFG_SSSP_ENABLE == true */
 
 /**
  * @brief   Retrieves the system uptime.
@@ -983,15 +1006,15 @@ void aosSysShutdownInit(aos_shutdown_t shutdown)
   // update the system SSSP stage
   aos.sssp.stage = AOS_SSSP_SHUTDOWN_1_1;
 
-  // activate the SYS_PD control signal only, if this module initiated the shutdown
   chSysLock();
+  // activate the SYS_PD control signal only, if this module initiated the shutdown
   if (shutdown != AOS_SHUTDOWN_PASSIVE) {
     apalControlGpioSet(&moduleSsspGpioPd, APAL_GPIO_ON);
   }
   // activate the SYS_SYNC signal
   apalControlGpioSet(&moduleSsspGpioSync, APAL_GPIO_ON);
   chSysUnlock();
-#endif
+#endif /* AMIROOS_CFG_SSSP_ENABLE == true */
 
   switch (shutdown) {
     case AOS_SHUTDOWN_PASSIVE:
@@ -1014,15 +1037,17 @@ void aosSysShutdownInit(aos_shutdown_t shutdown)
       chEvtBroadcastFlags(&aos.events.os, AOS_SYSTEM_EVENTFLAGS_RESTART);
       aosprintf("restarting system...\n");
       break;
-   // must never occur
-   case AOS_SHUTDOWN_NONE:
-   default:
+    // must never occur
+    case AOS_SHUTDOWN_NONE:
+    default:
       break;
   }
+
 #if (AMIROOS_CFG_SSSP_ENABLE == true)
   // update the system SSSP stage
   aos.sssp.stage = AOS_SSSP_SHUTDOWN_1_2;
 #endif
+
   return;
 }
 
@@ -1060,32 +1085,41 @@ void aosSysShutdownFinal(aos_shutdown_t shutdown)
   // disable all interrupts
   irqDeinit();
 
-  #if (AMIROOS_CFG_SSSP_ENABLE == true)
+#if (AMIROOS_CFG_SSSP_ENABLE == true)
   // update the system SSSP stage
   aos.sssp.stage = AOS_SSSP_SHUTDOWN_1_3;
 #endif
 
-  // call bootloader callback depending on arguments
-  switch (shutdown) {
-    case AOS_SHUTDOWN_PASSIVE:
-      BL_CALLBACK_TABLE_ADDRESS->cbHandleShutdownRequest();
-      break;
-    case AOS_SHUTDOWN_HIBERNATE:
-      BL_CALLBACK_TABLE_ADDRESS->cbShutdownHibernate();
-      break;
-    case AOS_SHUTDOWN_DEEPSLEEP:
-      BL_CALLBACK_TABLE_ADDRESS->cbShutdownDeepsleep();
-      break;
-    case AOS_SHUTDOWN_TRANSPORTATION:
-      BL_CALLBACK_TABLE_ADDRESS->cbShutdownTransportation();
-      break;
-    case AOS_SHUTDOWN_RESTART:
-      BL_CALLBACK_TABLE_ADDRESS->cbShutdownRestart();
-      break;
-    // must never occur
-    case AOS_SHUTDOWN_NONE:
-    default:
-      break;
+  // validate bootloader
+  if ((BL_CALLBACK_TABLE_ADDRESS->magicNumber == BL_MAGIC_NUMBER) &&
+      (BL_CALLBACK_TABLE_ADDRESS->vBootloader.major == BL_VERSION_MAJOR) &&
+      (BL_CALLBACK_TABLE_ADDRESS->vBootloader.minor >= BL_VERSION_MINOR)) {
+    // call bootloader callback depending on arguments
+    switch (shutdown) {
+      case AOS_SHUTDOWN_PASSIVE:
+        BL_CALLBACK_TABLE_ADDRESS->cbHandleShutdownRequest();
+        break;
+      case AOS_SHUTDOWN_HIBERNATE:
+        BL_CALLBACK_TABLE_ADDRESS->cbShutdownHibernate();
+        break;
+      case AOS_SHUTDOWN_DEEPSLEEP:
+        BL_CALLBACK_TABLE_ADDRESS->cbShutdownDeepsleep();
+        break;
+      case AOS_SHUTDOWN_TRANSPORTATION:
+        BL_CALLBACK_TABLE_ADDRESS->cbShutdownTransportation();
+        break;
+      case AOS_SHUTDOWN_RESTART:
+        BL_CALLBACK_TABLE_ADDRESS->cbShutdownRestart();
+        break;
+      // must never occur
+      case AOS_SHUTDOWN_NONE:
+      default:
+        break;
+    }
+  } else {
+    // fallback if bootloader was found to be invalid
+    aosprintf("Bootloader incompatible or not available!\n");
+    chThdSleep(TIME_INFINITE);
   }
 
   return;
diff --git a/core/src/aos_thread.c b/core/src/aos_thread.c
index e08fe72..ecd3e58 100644
--- a/core/src/aos_thread.c
+++ b/core/src/aos_thread.c
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -57,7 +57,7 @@ void aosThdSleepUntilS(const aos_timestamp_t* t)
   return;
 }
 
-#if (CH_DBG_FILL_THREADS == TRUE) || defined(__DOXYGEN__)
+#if ((AMIROOS_CFG_DBG == true) && (CH_DBG_FILL_THREADS == TRUE)) || defined(__DOXYGEN__)
 /**
  * @brief   Calculate the peak stack utilization for a specific thread so far in bytes.
  *
@@ -81,6 +81,6 @@ size_t aosThdGetStackPeakUtilization(thread_t* thread)
 
   return util;
 }
-#endif /* CH_DBG_FILL_THREADS == TRUE */
+#endif /* (AMIROOS_CFG_DBG == true) && (CH_DBG_FILL_THREADS == TRUE) */
 
 /** @} */
diff --git a/core/src/aos_time.c b/core/src/aos_time.c
index e637810..677733c 100644
--- a/core/src/aos_time.c
+++ b/core/src/aos_time.c
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/core/src/aos_timer.c b/core/src/aos_timer.c
index 1a7a4fc..d29e9bf 100644
--- a/core/src/aos_timer.c
+++ b/core/src/aos_timer.c
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/core/src/aos_unittest.c b/core/src/aos_unittest.c
index 8dd8fa3..d436894 100644
--- a/core/src/aos_unittest.c
+++ b/core/src/aos_unittest.c
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/doc/AMiRo-OS.uml b/doc/AMiRo-OS.uml
index de66b38..2b745ab 100644
--- a/doc/AMiRo-OS.uml
+++ b/doc/AMiRo-OS.uml
@@ -1,6 +1,6 @@
 /'
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/doc/dox/blt.dox b/doc/dox/blt.dox
index 604c865..2e8d3fe 100644
--- a/doc/dox/blt.dox
+++ b/doc/dox/blt.dox
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/doc/dox/configs.dox b/doc/dox/configs.dox
index 9d7c077..dda7f7f 100644
--- a/doc/dox/configs.dox
+++ b/doc/dox/configs.dox
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/doc/dox/core.dox b/doc/dox/core.dox
index b2157e3..1bd0e9e 100644
--- a/doc/dox/core.dox
+++ b/doc/dox/core.dox
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/doc/dox/kernel.dox b/doc/dox/kernel.dox
index b86640f..21d5651 100644
--- a/doc/dox/kernel.dox
+++ b/doc/dox/kernel.dox
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/doc/dox/modules.dox b/doc/dox/modules.dox
index dcd6576..c836d4a 100644
--- a/doc/dox/modules.dox
+++ b/doc/dox/modules.dox
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
diff --git a/kernel/kernelsetup.sh b/kernel/kernelsetup.sh
index 5bf200c..f8aced8 100755
--- a/kernel/kernelsetup.sh
+++ b/kernel/kernelsetup.sh
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-OS is an operating system designed for the Autonomous Mini Robot       #
 # (AMiRo) platform.                                                            #
-# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2019  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
@@ -263,6 +263,40 @@ function setLogFile {
   return 0
 }
 
+### check whether commands are available #######################################
+# Checks whether the specified commands are available and can be executed.
+#
+# usage:      checkCommand [<command> <command> ...]
+# arguments:  <command>
+#                 Name of the command to check.
+# return:     0
+#                 All requested commands are available.
+#             >0
+#                 Number of requested commands that were not found.
+#             -1
+#                 No argument given.
+#
+function checkCommands {
+  local status=0
+
+  # return if no argument was specified
+  if [ $# -eq 0 ]; then
+    return -1
+  fi
+
+  # check all specified commands
+  while [ $# -gt 0 ]; do
+    command -v $1 &>/dev/null
+    if [ $? -ne 0 ]; then
+      printWarning "Command '$1' not available.\n"
+      status=$((status + 1))
+    fi
+    shift 1
+  done
+
+  return $status
+}
+
 ################################################################################
 # SPECIFIC FUNCTIONS                                                           #
 ################################################################################
@@ -281,7 +315,7 @@ function printWelcomeText {
   printf "#                                                                    #\n"
   printf "######################################################################\n"
   printf "#                                                                    #\n"
-  printf "# Copyright (c) 2016..2018  Thomas Schöpping                         #\n"
+  printf "# Copyright (c) 2016..2019  Thomas Schöpping                         #\n"
   printf "#                                                                    #\n"
   printf "# This is free software; see the source for copying conditions.      #\n"
   printf "# There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR  #\n"
@@ -333,6 +367,8 @@ function printHelp {
 #                 Warning: Aborted by user.
 #             -1
 #                 Error: Unexpected user input.
+#             -1
+#                 Error: Missing dependency.
 #
 function initChibiOS {
   printInfo "initializing ChibiOS submodule...\n"
@@ -358,6 +394,13 @@ function initChibiOS {
     esac
   fi
 
+  # check dependencies
+  checkCommands git
+  if [ $? -ne 0 ]; then
+    printError "Missing dependencies detected.\n"
+    return -2
+  fi
+
   # initialize submodule to default branch
   cd $kerneldir
   git submodule update --init $chibiosdir 2>&1 | tee -a $LOG_FILE
@@ -403,6 +446,13 @@ function patchChibiOS {
   local chibiosdir=${kerneldir}/ChibiOS
   local git_branch_patched="AMiRo-OS"
 
+  # check dependencies
+  checkCommands git
+  if [ $? -ne 0 ]; then
+    printError "Missing dependencies detected.\n"
+    return -2
+  fi
+
   # if the ChibiOS folder is empty
   if [ -z "$(ls -A $chibiosdir)" ]; then
     printWarning "$chibiosdir is empty. Please initialize first.\n"
@@ -615,6 +665,13 @@ function wipeChibiOS {
   local chibiosdir=${kerneldir}/ChibiOS
   local git_branch_patched="AMiRo-OS"
 
+  # check dependencies
+  checkCommands git
+  if [ $? -ne 0 ]; then
+    printError "Missing dependencies detected.\n"
+    return -2
+  fi
+
   # if the ChibiOS folder is empty
   if [ -z "$(ls -A $chibiosdir)" ]; then
     printInfo "$chibiosdir is alread empty\n"
